算法每日一题: Nim游戏 | 找规律

哈哈,大家好,我是星恒,今天的每日一题真开心,连做了3天牢,终于ak了一道,太不容易了

这道题其实就是找规律,刚开始我还以为是动归,但是列举了不少例子之后,发现有自己直接的规律,ok,直接通过

期待大家和我有一样的体验哈!让我们来看一看吧!

题目:leetcode 292

你和你的朋友,两个人一起玩 Nim 游戏:

  • 桌子上有一堆石头。
  • 你们轮流进行自己的回合, **你作为先手 **。
  • 每一回合,轮到的人拿掉 1 - 3 块石头。
  • 拿掉最后一块石头的人就是获胜者。

假设你们每一步都是最优解。请编写一个函数,来判断你是否可以在给定石头数量为 n 的情况下赢得游戏。如果可以赢,返回 true;否则,返回 false 。

示例:
示例 1:

复制代码
输入:n = 4
输出:false 
解释:以下是可能的结果:
1. 移除1颗石头。你的朋友移走了3块石头,包括最后一块。你的朋友赢了。
2. 移除2个石子。你的朋友移走2块石头,包括最后一块。你的朋友赢了。
3.你移走3颗石子。你的朋友移走了最后一块石头。你的朋友赢了。
在所有结果中,你的朋友是赢家。

示例 2:

复制代码
输入:n = 1
输出:true

示例 3:

复制代码
输入:n = 2
输出:true

提示:

  • 1 <= n <= 231 - 1

分析:

这道题的本质就是找规律,大家多列举几个例子,其实答案就出来啦

规律枚举在题解代码中写出:

题解:

java 复制代码
/*
    找规律
    n = 0 先手必输

    n = 1 先手全拿走 后手必输
    n = 2 先手全拿走 后手必输
    n = 3 先手全拿走 后手必输
    n = 4 先手无论怎么拿 都会剩下1或2或3 先手必输
    
    n = 5 先手拿走1个给后手制造n == 4 后手不管怎么拿,都不会造出4来 后手必输
    n = 6 先手拿走2个给后手制造n == 4 后手不管怎么拿,都不会造出4来 后手必输
    n = 7 先手拿走3个给后手制造n == 4 后手不管怎么拿,都不会造出4来 后手必输
    n = 8 先手无论怎么拿 后手必能制造出4来 先手必输
    ...
*/
class Solution {
    public boolean canWinNim(int n) {
        if (n % 4 == 0) {
            return false;
        } 
        return true;
    }
}
相关推荐
hanlin038 小时前
刷题笔记:力扣第32题-最长有效括号
笔记·算法·leetcode
All for pursuit.9 小时前
【动态规划-21】312.戳气球
数据结构·c++·算法·leetcode·动态规划
碧海银沙音频科技研究院11 小时前
基于炬芯ATS3089X自研AEC声学回声消除算法
算法
通问AI11 小时前
在两台 Mac Studio 上跑 800B 模型:MLX + RDMA over Thunderbolt 实测与四道门选型法
算法
ZywOo62311 小时前
《算法竞赛进阶指南》0x03 前缀和与差分
算法
Scintilla_y11 小时前
DAY2 滑动窗口
算法·leetcode·散列表
lvwangshu11 小时前
笛卡尔树
算法·图论
026d2312 小时前
状态信号只知“其然”不知“其所以然”:变工况机械故障诊断的物理盲区
算法
姜鱼问生12 小时前
备份和服务器在同一台机器上,等于没备份
算法·架构
姜鱼问生12 小时前
别再 chmod 777 了,用 ACL 给它开一扇窗
后端·算法·架构